//
//  ATKAppDelegate.h
//  ExampleApplication
//
//  Created by Nick Kitchener on 07/01/2013.
//  Copyright (c) 2013 ATIK. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#import <ATIKOSXDrivers/ATIKOSXDrivers.h>
#import <ATIKOSXLegacyDrivers/ATIKOSXLegacyDrivers.h>
#import "ATKMainWindowController.h"
#import "ATKDeviceControllerManager.h"

@interface ATKAppDelegate : NSObject <NSApplicationDelegate> {
    ATIKOSXDrivers          *_modernDrivers;
    ATIKOSXLegacyDrivers    *_legacyDrivers;
    
    ATKMainWindowController *_mainWindowController;
    
}

//@property (assign) IBOutlet NSWindow *window;
@property (readwrite, retain, nonatomic) ATKDeviceControllerManager   *controllerManager;
@property (assign, assign, nonatomic) IBOutlet NSWindow *preferencesWindow;
@property (assign, assign, nonatomic) IBOutlet NSTextField *versionField;
@property (readonly, assign, nonatomic) NSString *driverVersion;

-(void)applicationDidFinishLaunching:(NSNotification *)aNotification;
-(void)applicationWillTerminate:(NSNotification *)notification;

-(IBAction)addTestCameraInstance:(id)sender;
-(IBAction)addTestLegacyCameraInstance:(id)sender;
-(IBAction)addTestFilterWheelInstance:(id)sender;
-(IBAction)removeTestCameraInstance:(id)sender;
-(IBAction)removeTestFilterWheelInstance:(id)sender;

@end

@interface ATKAppDelegate (ATIKOSXDriverNotificationDelegate) <ATIKOSXDriverNotificationDelegate>
@end
