//
//  ATKCameraLiveViewController.h
//  ExampleApplication
//
//  Created by Nick Kitchener on 24/01/2013.
//  Copyright (c) 2013 atik. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <Quartz/Quartz.h>
#import "ATKCameraController.h"
#import "ATKLiveUpdateDelegate.h"
#import "ATKStatusView.h"
#import "ATKLiveViewHIDDelegate.h"

@interface ATKCameraLiveViewController : NSViewController <ATKLiveViewHIDDelegate> {
    NSNumber *_exposure;
}

@property(readwrite, assign, nonatomic) IBOutlet ATKStatusView *statusView;
@property(readwrite, assign, nonatomic) IBOutlet IKImageView *imageView;
@property(readwrite, assign, nonatomic) ATKCameraController *cameraController;
@property(readwrite, assign, nonatomic) NSString    *identity;
@property(readwrite, retain, nonatomic) NSNumber    *exposure;
@property(readwrite, assign, nonatomic) NSUInteger  numberOfExposures;
@property(readwrite, assign, nonatomic) NSNumber    *targetTemperature;
@property(readwrite, assign, nonatomic) NSNumber    *temperature;
@property(readwrite, assign, nonatomic) NSURL       *storagePath;
@property(readwrite, assign, nonatomic) NSString       *currentState;


-(void)startPreviewMode;

-(void)abort;

-(void)guide:(long)direction;

-(void)setStateObserver:(NSObject<StateObserver>*)observer;


@end

@interface ATKCameraLiveViewController (ATKLiveUpdateDelegate) <ATKLiveUpdateDelegate>

-(void)replaceLiveImage:(NSImage*)newImage;


@end