//
//  ATKCollectionSubView.m
//  ExampleApplication
//
//  Created by Nick Kitchener on 27/01/2013.
//  Copyright (c) 2013 atik. All rights reserved.
//
//  This is a custom sub-view used by the NSCollectionView

#import "ATKCollectionSubView.h"

@implementation ATKCollectionSubView

-(id)copyWithZone:(NSZone*)zone {
    ATKCollectionSubView *theCopy = [[ATKCollectionSubView allocWithZone:zone] initWithFrame:[self frame]];
    [theCopy setSelected:[self selected]];
    return theCopy;
}

- (id)initWithFrame:(NSRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code here.
    }
    
    return self;
}

-(void)drawRect:(NSRect)rect {
    [super drawRect:rect];
}


-(NSView *)hitTest:(NSPoint)aPoint {
    // don't allow any mouse clicks for subviews in this view
    if(NSPointInRect(aPoint,[self convertRect:[self bounds] toView:[self superview]])) {
        return self;
    } else {
        return nil;
    }
}

-(void)mouseDown:(NSEvent *)theEvent {
    [super mouseDown:theEvent];

    if([_delegate respondsToSelector:@selector(selectCollectionViewItem:)]) {
        [_delegate selectCollectionViewItem:self];
    }
    self.selected=YES;
}



@end
