//
//  ATKDeviceControllerManager.h
//  ExampleApplication
//
//  Created by Nick Kitchener on 25/01/2013.
//  Copyright (c) 2013 atik. All rights reserved.
//
//  An top level containing the controllers
//  keeps in sync with the devices being attached/detached.

#import <Foundation/Foundation.h>
#import <ATIKOSXDrivers/ATIKOSXDrivers.h>
#import <ATIKOSXLegacyDrivers/ATIKOSXLegacyDrivers.h>
#import <ATIKOSXDrivers/ATIKOSXDriverNotificationDelegate.h>
#import "ATKControllerManagement.h"

@interface ATKDeviceControllerManager : NSObject

@property(readwrite, strong, nonatomic) NSMutableDictionary *identityToDeviceController;
@property(readwrite, strong, nonatomic) NSMutableArray *managedObjectArray;
@property(readwrite, assign, nonatomic) NSArrayController *arrayControllerDelegate;

@property(readwrite, assign, nonatomic) ATIKOSXDrivers *modernDrivers;
@property(readwrite, assign, nonatomic) ATIKOSXLegacyDrivers *legacyDrivers;

@end

@interface ATKDeviceControllerManager (ATIKOSXDriverNotificationDelegate) <ATIKOSXDriverNotificationDelegate>

-(void)deviceConnected:(NSString*)identity;
-(void)deviceDisconnected:(NSString*)identity;

@end
