//
//  ATKFilterWheelController.h
//  ExampleApplication
//
//  Created by Nick Kitchener on 24/01/2013.
//  Copyright (c) 2013 atik. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "ATKControllerManagement.h"

#import <ATIKOSXDrivers/ATIKOSXDrivers.h>
#import "ATKLiveUpdateDelegate.h"

@interface ATKFilterWheelController : NSObject <ATKControllerManagement> {
    id<FilterWheel100> filterWheel;
    NSObject<StateObserver> *_stateObserver;
}

-(id)initWithFilterWheel:(id<FilterWheel100>)device;

@property(readwrite,assign, nonatomic) NSArray *availableFilters;

@property(readwrite, assign, nonatomic) NSString *identity;
@property (readwrite, assign, nonatomic) NSImage    *icon;
@property (readwrite, assign, atomic) NSObject<ATKLiveUpdateDelegate> *liveView;

-(void)selectFilter:(NSString*)filter;
-(NSString*)filter;

-(void)shutdown;

-(void)setStateObserver:(NSObject<StateObserver>*)observer;
-(void)setState:(NSString*)newState;

@end
