//
//  ATKFilterWheelController.m
//  ExampleApplication
//
//  Created by Nick Kitchener on 24/01/2013.
//  Copyright (c) 2013 atik. All rights reserved.
//

#import "ATKFilterWheelController.h"

@implementation ATKFilterWheelController

-(id)initWithFilterWheel:(id<FilterWheel100>)device {
    self=[super init];
    if(self) {
        filterWheel = device;
        // this is here until we finish FW live view..

    }
    return self;
}

-(void)shutdown {
    filterWheel=nil;
}

-(NSArray*)availableFilters {
    NSArray *returned = [[filterWheel availableFilters]allValues];
    NSLog(@"returned %@", returned);
    return returned;
}

-(void)selectFilter:(NSString*)filter {
    NSArray *a = [[filterWheel availableFilters]allKeysForObject:filter];
    NSNumber *p = [a objectAtIndex:0];
    [filterWheel setPosition:[p intValue]];
}

-(NSString*)filter {
    int p = [filterWheel position];
    return [[filterWheel availableFilters]objectForKey:[NSNumber numberWithInt:p]];
}


-(NSString*)identity {
    return [filterWheel uniqueIdentity];
}

-(NSImage*)icon {
    return [NSImage imageNamed:@"ATIK EFW2"];
}

-(NSString*)model {
    return [filterWheel model];
}

-(void)setState:(NSString*)newState {
    [_liveView performSelectorOnMainThread:@selector(stateState:) withObject:newState waitUntilDone:YES];
}

-(void)setStateObserver:(NSObject<StateObserver>*)observer {
    _stateObserver = observer;
    [filterWheel setStateObserver:observer];
}

@end
