//
//  ATKImageSub.h
//  ExampleApplication
//
//  Created by Nick Kitchener on 03/02/2013.
//  Copyright (c) 2013 atik. All rights reserved.
//

// An NSImage substitute that maintains the image buffer during
// it's lifetime and deallocates it when ARC garbage collects.

#import <Cocoa/Cocoa.h>
#include <ATIKOSXDrivers/ATIKOSXDrivers.h>

@interface ATKImageSub : NSImage {
    ImageFrame *_image;
    NSBitmapImageRep *bitmapRep;
}

-(id)initWithImageFrame:(ImageFrame*)image;
-(void)dealloc;

-(void)explicitReleaseSelfAllocated;

@end
