//
//  ATKImageSub.m
//  ExampleApplication
//
//  Created by Nick Kitchener on 03/02/2013.
//  Copyright (c) 2013 atik. All rights reserved.
//

#import "ATKImageSub.h"

@implementation ATKImageSub

-(id)initWithImageFrame:(ImageFrame*)image {
    self = [super initWithSize:NSMakeSize(image.width, image.height)];
    if(self) {
        _image = image; // keep a reference so ARC doesn't dealloc the image buffer;
        
        uint8_t *input = (uint8_t*) _image.imagebuffer;
        
        unsigned char *planes[1];
        planes[0]=(unsigned char*)input;
        
        bitmapRep = [[NSBitmapImageRep alloc] initWithBitmapDataPlanes:planes
                                                                              pixelsWide:_image.width
                                                                              pixelsHigh:_image.height
                                                                           bitsPerSample:16
                                                                         samplesPerPixel:1
                                                                                hasAlpha:NO
                                                                                isPlanar:NO
                                                                          colorSpaceName:NSCalibratedWhiteColorSpace
                                                                            bitmapFormat:0
                                                                             bytesPerRow:(2 * _image.width)
                                                                            bitsPerPixel:16];
        
        if(bitmapRep==NULL) {
            NSLog(@"oops");
        }
        
        if( bitmapRep!=nil) {
            [super addRepresentation:bitmapRep];
        }
    }
    return self;
}

-(void)dealloc {
    if( bitmapRep!=nil)
        [super removeRepresentation:bitmapRep];
    bitmapRep=nil;
    [_image explicitReleaseSelfAllocated]; // force deallocation of image buffer rather than relying on ARC garbage..
    _image=nil;
#if ! __has_feature(objc_arc)
    [super dealloc];
#endif
}

-(void)explicitReleaseSelfAllocated {
    [_image explicitReleaseSelfAllocated];
}

@end
