//
//  ATKLiveViewHIDDelegate.h
//  ExampleApplication
//
//  Created by Nick Kitchener on 02/02/2013.
//  Copyright (c) 2013 atik. All rights reserved.
//

#import <Foundation/Foundation.h>

#include <ATIKOSXDrivers/StateObserver.h>

@protocol ATKLiveViewHIDDelegate <NSObject>

@property(readwrite, assign, nonatomic) NSString    *identity;
@property(readwrite, retain, nonatomic) NSNumber    *exposure;
@property(readwrite, assign, nonatomic) NSUInteger  numberOfExposures;
@property(readwrite, assign, nonatomic) NSNumber    *targetTemperature;
@property(readonly, assign, nonatomic) NSNumber     *temperature;
@property(readwrite, assign, nonatomic) NSURL       *storagePath;

@property(readwrite, assign, nonatomic) NSNumber    *previewMode;
@property(readwrite, assign, nonatomic) NSNumber    *xBin;
@property(readwrite, assign, nonatomic) NSNumber    *yBin;

@property(readwrite, assign, nonatomic) NSNumber    *enableSubsample;
@property(readwrite, assign, nonatomic) NSNumber    *enablePrecharge;
@property(readwrite, assign, nonatomic) NSNumber    *enableTitanAutoBlackLevel;
@property(readwrite, assign, nonatomic) NSNumber    *prechargeValue;

@property(readonly, assign, nonatomic) NSString    *currentState;

-(void)setStateObserver:(NSObject<StateObserver>*)observer;

-(void)startPreviewMode;
-(void)startCapture;
-(void)startWarmUp;
-(void)abort;

-(void)guide:(long)direction;

@end
