//
//  ATKMainWindowController.h
//  ExampleApplication
//
//  Created by Nick Kitchener on 24/01/2013.
//  Copyright (c) 2013 atik. All rights reserved.
//

// The main window has
//  * collective view for seeing and selecting devices to show in the tabbed view
//  * tabbed view containing the currently selected device:
//      * live view
//      * properties
//      * debug log

#import <Cocoa/Cocoa.h>
#import "ATKDeviceControllerManager.h"
#import "ATKCameraController.h"
#import "ATKLiveViewHIDController.h"

@interface ATKMainWindowController : NSWindowController {
    NSMutableDictionary  *viewControllers;
    
    
#if __MAC_OS_X_VERSION_MAX_ALLOWED < MAC_OS_X_VERSION_10_8
    ATKLiveViewHIDController *liveViewHIDController;
    NSIndexSet *selectionIndexSet;
    IBOutlet NSView*     liveViewParentView;         // the host view
    NSViewController*	currentLiveViewController;	// the current view controller
    NSMutableDictionary *serialToChipId;
    IBOutlet NSArrayController   *arrayController;
    ATKDeviceControllerManager *deviceControllerManager;
    IBOutlet NSCollectionView *collectionView;
    NSNumber *debugCheckBox;
#endif
    
}

@property (readwrite, strong, nonatomic) ATKLiveViewHIDController *liveViewHIDController;
@property (readwrite, strong, nonatomic) NSIndexSet *selectionIndexSet;
@property (assign, nonatomic)  IBOutlet NSView*     liveViewParentView;         // the host view
@property (readwrite, assign, nonatomic)  NSViewController*	currentLiveViewController;	// the current view controller
@property (readwrite, strong, nonatomic) NSMutableDictionary *serialToChipId;

@property (assign, nonatomic) IBOutlet NSArrayController   *arrayController;
//@property (strong, nonatomic) NSMutableArray *managedObjectArray;

@property (assign, readwrite, nonatomic) ATKDeviceControllerManager *deviceControllerManager;

//@property (readwrite) NSUInteger *currentSelected;
@property (assign, nonatomic) IBOutlet NSCollectionView *collectionView;

@property (readwrite, assign, nonatomic) NSNumber *debugCheckBox;

-(IBAction)selectCollectionViewItem:(id)sender;

-(void)deactivateLiveViewHID;
@end
